import os
import jwt
import six

from jwt.exceptions import PyJWTError
from werkzeug.exceptions import Unauthorized

jwt_key_pub_path = f'{os.path.abspath(os.path.dirname(__file__))}/jwt-key.pub'


def decode_token(token):
    """
    Function responsible for decode the token informed by the client

    :param token:   JWT Token
    :return:        json decoded
    :raise:         Unauthorized when token is invalid
    """
    try:
        return jwt.decode(token, jwt_key_pub_path, algorithms=[config.JWT_ALGORITHM])
    except PyJWTError as e:
        six.raise_from(Unauthorized, e)
